SystemOrganization addCategory: #'TinyWiki-Core'!
SystemOrganization addCategory: #'TinyWiki-Document'!
SystemOrganization addCategory: #'TinyWiki-Parser'!
SystemOrganization addCategory: #'TinyWiki-Component'!

SmaCCParser subclass: #TWParser
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Parser'!

!TWParser methodsFor: 'private' stamp: 'lr 3/26/2004 23:55'!
createDocument
	^TWDocument withAll: items! !

!TWParser class methodsFor: 'generated-accessing' stamp: 'lr 3/27/2004 12:56'!
scannerClass
	^TWScanner! !

!TWParser methodsFor: 'generated-reduction actions' stamp: 'lr 3/27/2004 12:56'!
reduceActionForParagraphItems3: nodes 
	^(nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!TWParser methodsFor: 'generated-reduction actions' stamp: 'lr 3/27/2004 12:56'!
reduceActionForList1: nodes 
	^self addListItem: (TWListItem withAll: (nodes at: 2))
		ofType: (nodes at: 1) value first! !

!TWParser methodsFor: 'private' stamp: 'lr 3/27/2004 00:41'!
buildText: aString
	| index reading read |
	^Array streamContents: [ :stream |
		TWSmiley smilies do: [ :smiley |
			index _ aString findString: smiley.
			index isZero ifFalse: [
				reading _ aString readStream.
				read _ reading upToAll: smiley.
				read isEmpty ifFalse: [ stream nextPutAll: (self buildText: read) ].
				stream nextPut: (TWSmiley text: smiley).
				read _ reading upToEnd.
				read isEmpty ifFalse: [ stream nextPutAll: (self buildText: read) ].
				^stream contents ] ].
		stream nextPut: (TWText text: aString) ]! !

!TWParser methodsFor: 'private' stamp: 'lr 3/27/2004 08:47'!
addHeading: aCollection level: anInteger
	items add: (TWHeading withAll: aCollection level: anInteger)! !

!TWParser methodsFor: 'generated-tables' stamp: 'lr 3/27/2004 12:56'!
reduceTable
	^#(
#(10 2 #reduceActionForList1:)
#(11 1 #reduceFor:)
#(11 1 #reduceFor:)
#(11 1 #reduceFor:)
#(11 1 #reduceFor:)
#(12 2 #reduceActionForHeading1:)
#(13 1 #reduceFor:)
#(14 0 #reduceActionForParagraphItems1:)
#(14 2 #reduceActionForParagraphItems2:)
#(14 2 #reduceActionForParagraphItems3:)
#(15 1 #createDocument)
#(16 1 #reduceActionForParagraphStart1:)
#(16 1 #reduceActionForParagraphStart2:)
#(16 1 #reduceActionForParagraphStart3:)
#(16 1 #reduceActionForParagraphStart4:)
#(17 1 #addRule)
#(18 1 #reduceFor:)
#(18 3 #reduceFor:)
#(18 3 #reduceFor:)
#(18 2 #reduceFor:)
#(18 2 #reduceFor:)
#(19 3 #reduceActionForLink1:)
#(20 1 #addEmptyParagraph)
#(21 2 #reduceActionForParagraph1:)
#(22 0 #reduceActionForLinkItems1:)
#(22 2 #reduceActionForLinkItems2:)
)! !

!TWParser methodsFor: 'private' stamp: 'lr 3/27/2004 08:42'!
addParagraph: aCollection
	items add: (TWParagraph withAll: aCollection)! !

!TWParser methodsFor: 'generated-reduction actions' stamp: 'lr 3/27/2004 12:56'!
reduceActionForParagraphItems1: nodes 
	^OrderedCollection new! !

!TWParser methodsFor: 'private' stamp: 'lr 3/27/2004 00:59'!
addListItem: aListItem ofType: aCharacter 
	| newList |
	newList _ items isEmpty 
		or: [ items last class ~= TWList ]
		or: [ items last type ~= aCharacter ].
	newList
		ifTrue: [ items add: ((TWList type: aCharacter) add: aListItem) ]
		ifFalse: [ items last add: aListItem ]! !

!TWParser methodsFor: 'generated-reduction actions' stamp: 'lr 3/27/2004 12:56'!
reduceActionForParagraph1: nodes 
	^self addParagraph: (nodes at: 1) , (nodes at: 2)! !

!TWParser methodsFor: 'generated-reduction actions' stamp: 'lr 3/27/2004 12:56'!
reduceActionForParagraphItems2: nodes 
	^(nodes at: 1)
		addAll: (self buildText: (nodes at: 2) value);
		yourself! !

!TWParser class methodsFor: 'generated-comments' stamp: 'lr 3/27/2004 12:56'!
parserDefinitionComment

	"# basic document structure
Document		: DocumentItems { #createDocument } ;
DocumentItems	: DocumentItem
				| DocumentItems <newline> DocumentItem
				| DocumentItems BlankLine DocumentItem
				| DocumentItems <newline>
				| DocumentItems BlankLine ; 
BlankLine 		: <blankLine> { #addEmptyParagraph } ;
DocumentItem	: Rule
				| Heading
				| List
				| Paragraph ;

# basic elements
Rule			: <rule> { #addRule } ;
			
Heading			: <header> 'header' ParagraphItems 'items' { self addHeading: items level: header value size } ;

List				: <list> 'type' ParagraphItems 'items' { self addListItem: (TWListItem withAll: items) ofType: type value first };
				
Paragraph		: ParagraphStart 'firstItem' ParagraphItems 'items' { self addParagraph: firstItem , items } ;
				
# paragraph text
ParagraphStart	: <text> 'text' { self buildText: text value } 
				| <nonLinkStart> 'text' { self buildText: text value last asString } 
				| Link 'link' { OrderedCollection with: link }
				| <any> 'text' { self buildText: text value } ;
				
ParagraphItems : { OrderedCollection new }
				| ParagraphItems 'nodes' <text> 'text' { nodes addAll: (self buildText: text value); yourself }
				| ParagraphItems 'nodes' Link 'link' { nodes add: link; yourself } ;
				
# link
Link			: <link> LinkItems 'nodes' <link> { TWReference withAll: nodes } ;
LinkItems 		: { OrderedCollection new }
				| LinkItems 'nodes' <text> 'text' { nodes addAll: (self buildText: text value); yourself } ;"! !

!TWParser methodsFor: 'generated-reduction actions' stamp: 'lr 3/27/2004 12:56'!
reduceActionForLinkItems1: nodes 
	^OrderedCollection new! !

!TWParser methodsFor: 'generated-reduction actions' stamp: 'lr 3/27/2004 12:56'!
reduceActionForParagraphStart2: nodes 
	^self buildText: (nodes at: 1) value last asString! !

!TWParser methodsFor: 'private' stamp: 'lr 3/27/2004 12:53'!
addEmptyParagraph
	items add: TWParagraph new! !

!TWParser methodsFor: 'generated-tables' stamp: 'lr 3/27/2004 12:56'!
transitionTable
	^#(
#(3 9 3 13 4 17 5 21 6 25 7 29 8 33 9 37 10 41 11 45 12 49 15 53 16 57 17 61 18 65 19 69 21)
#(2 66 1 2 23)
#(3 34 1 34 2 34 6 34 8 73 14 34 23)
#(3 34 1 34 2 34 6 34 8 77 14 34 23)
#(3 102 6 102 8 81 22)
#(2 54 1 2 6 8 23)
#(2 50 1 2 6 8 23)
#(2 62 1 2 6 8 23)
#(2 18 1 2 23)
#(2 70 1 2 23)
#(2 14 1 2 23)
#(2 0 23)
#(3 34 1 34 2 34 6 34 8 85 14 34 23)
#(2 10 1 2 23)
#(3 89 1 93 2 97 20 46 23)
#(2 58 1 2 6 8 23)
#(2 22 1 2 23)
#(3 26 1 26 2 21 6 101 8 105 19 26 23)
#(3 6 1 6 2 21 6 101 8 105 19 6 23)
#(3 109 6 113 8)
#(3 98 1 98 2 21 6 101 8 105 19 98 23)
#(3 82 1 82 2 9 3 13 4 17 5 21 6 25 7 29 8 33 9 37 10 117 11 45 12 53 16 57 17 65 19 69 21 82 23)
#(2 94 1 2 3 4 5 6 7 8 9 23)
#(3 86 1 86 2 9 3 13 4 17 5 21 6 25 7 29 8 33 9 37 10 121 11 45 12 53 16 57 17 65 19 69 21 86 23)
#(2 38 1 2 6 8 23)
#(2 42 1 2 6 8 23)
#(2 90 1 2 6 8 23)
#(2 106 6 8)
#(2 74 1 2 23)
#(2 78 1 2 23)
)! !

!TWParser methodsFor: 'generated-reduction actions' stamp: 'lr 3/27/2004 12:56'!
reduceActionForLinkItems2: nodes 
	^(nodes at: 1)
		addAll: (self buildText: (nodes at: 2) value);
		yourself! !

!TWParser methodsFor: 'initialize-release' stamp: 'lr 3/26/2004 23:54'!
initialize
	super initialize.
	items _ OrderedCollection new.! !

!TWParser methodsFor: 'generated-reduction actions' stamp: 'lr 3/27/2004 12:56'!
reduceActionForParagraphStart1: nodes 
	^self buildText: (nodes at: 1) value! !

!TWParser methodsFor: 'generated-reduction actions' stamp: 'lr 3/27/2004 12:56'!
reduceActionForHeading1: nodes 
	^self addHeading: (nodes at: 2) level: (nodes at: 1) value size! !

!TWParser methodsFor: 'private' stamp: 'lr 3/26/2004 23:58'!
addRule
	items add: TWRule new! !

!TWParser methodsFor: 'generated-reduction actions' stamp: 'lr 3/27/2004 12:56'!
reduceActionForLink1: nodes 
	^TWReference withAll: (nodes at: 2)! !

!TWParser methodsFor: 'generated-reduction actions' stamp: 'lr 3/27/2004 12:56'!
reduceActionForParagraphStart4: nodes 
	^self buildText: (nodes at: 1) value! !

!TWParser class methodsFor: 'generated-starting states' stamp: 'lr 3/27/2004 12:56'!
startingStateForDocument
	^1! !

!TWParser methodsFor: 'generated-reduction actions' stamp: 'lr 3/27/2004 12:56'!
reduceActionForParagraphStart3: nodes 
	^OrderedCollection with: (nodes at: 1)! !

!TWParser methodsFor: 'private' stamp: 'lr 3/27/2004 08:39'!
addToDocument: anObject
	items addLast: anObject! !

SmaCCScanner subclass: #TWScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Parser'!

!TWScanner class methodsFor: 'generated-comments' stamp: 'lr 3/27/2004 12:56'!
scannerDefinitionComment

	"<newline>		: \r? \n | \r ;
<blankLine>		: <newline> <newline> ;

<rule>			: \_[\ \t]* ;
<header>			: \!!+ ;
<list>			: [\#\-\=] ;

<link>			: \* ;
<nonLinkStart>	: \*\* | \\ [\*\=\!!\#\-] ;

<text>			: [^\r\n\*\!!\#\-\=\\]+ ;
<any>			: . ;"! !

!TWScanner methodsFor: 'generated-scanner' stamp: 'lr 3/27/2004 12:56'!
scan1
	self recordMatch: #(2).
	self step.
	(currentCharacter == $
 or: [currentCharacter == $
]) 
		ifTrue: [^self recordAndReportMatch: #(2)].
	^self reportLastMatch! !

!TWScanner methodsFor: 'generated-tokens' stamp: 'lr 3/27/2004 12:56'!
emptySymbolTokenId
	^23! !

!TWScanner methodsFor: 'generated-tokens' stamp: 'lr 3/27/2004 12:56'!
errorTokenId
	^24! !

!TWScanner methodsFor: 'generated-scanner' stamp: 'lr 3/27/2004 12:56'!
scanForToken
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $ ) or: 
							[currentCharacter == $" or: 
									[(currentCharacter between: $$ and: $)) or: 
											[(currentCharacter between: $+ and: $,) or: 
													[(currentCharacter between: $. and: $<) or: 
															[(currentCharacter between: $> and: $[) 
																or: [(currentCharacter between: $] and: $^) or: [currentCharacter >= $`]]]]]]]]]) 
		ifTrue: 
			[self recordMatch: #(8 9).
			self step.
			(currentCharacter <= $	 or: 
					[(currentCharacter between: $ and: $) or: 
							[(currentCharacter between: $ and: $ ) or: 
									[currentCharacter == $" or: 
											[(currentCharacter between: $$ and: $)) or: 
													[(currentCharacter between: $+ and: $,) or: 
															[(currentCharacter between: $. and: $<) 
																or: [(currentCharacter between: $> and: $[) or: [currentCharacter >= $]]]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(8).
					self step.
					currentCharacter <= $	 or: 
							[(currentCharacter between: $ and: $) or: 
									[(currentCharacter between: $ and: $ ) or: 
											[currentCharacter == $" or: 
													[(currentCharacter between: $$ and: $)) or: 
															[(currentCharacter between: $+ and: $,) or: 
																	[(currentCharacter between: $. and: $<) 
																		or: [(currentCharacter between: $> and: $[) or: [currentCharacter >= $]]]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	(currentCharacter == $# 
		or: [currentCharacter == $- or: [currentCharacter == $=]]) 
			ifTrue: [^self recordAndReportMatch: #(5 9)].
	currentCharacter == $
 
		ifTrue: 
			[self recordMatch: #(1 9).
			self step.
			currentCharacter == $
 ifTrue: [^self recordAndReportMatch: #(2)].
			currentCharacter == $
 ifTrue: [^self scan1].
			^self reportLastMatch].
	currentCharacter == $
 
		ifTrue: 
			[self recordMatch: #(1 9).
			self step.
			(currentCharacter == $
 or: [currentCharacter == $
]) 
				ifTrue: 
					[self recordMatch: #(1 2).
					self step.
					currentCharacter == $
 ifTrue: [^self recordAndReportMatch: #(2)].
					currentCharacter == $
 ifTrue: [^self scan1].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $!! 
		ifTrue: 
			[self recordMatch: #(4 9).
			self step.
			currentCharacter == $!! 
				ifTrue: 
					[
					[self recordMatch: #(4).
					self step.
					currentCharacter == $!!] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $* 
		ifTrue: 
			[self recordMatch: #(6 9).
			self step.
			currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(7)].
			^self reportLastMatch].
	currentCharacter == $\ 
		ifTrue: 
			[self recordMatch: #(9).
			self step.
			(currentCharacter == $!! or: 
					[currentCharacter == $# or: 
							[currentCharacter == $* 
								or: [currentCharacter == $- or: [currentCharacter == $=]]]]) 
				ifTrue: [^self recordAndReportMatch: #(7)].
			^self reportLastMatch].
	currentCharacter == $_ 
		ifTrue: 
			[self recordMatch: #(3 8 9).
			self step.
			(currentCharacter <= $ or: 
					[(currentCharacter between: $ and: $) or: 
							[(currentCharacter between: $ and: $) or: 
									[currentCharacter == $" or: 
											[(currentCharacter between: $$ and: $)) or: 
													[(currentCharacter between: $+ and: $,) or: 
															[(currentCharacter between: $. and: $<) 
																or: [(currentCharacter between: $> and: $[) or: [currentCharacter >= $]]]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(8).
					self step.
					currentCharacter <= $	 or: 
							[(currentCharacter between: $ and: $) or: 
									[(currentCharacter between: $ and: $ ) or: 
											[currentCharacter == $" or: 
													[(currentCharacter between: $$ and: $)) or: 
															[(currentCharacter between: $+ and: $,) or: 
																	[(currentCharacter between: $. and: $<) 
																		or: [(currentCharacter between: $> and: $[) or: [currentCharacter >= $]]]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			(currentCharacter == $	 or: [currentCharacter == $ ]) 
				ifTrue: 
					[
					[self recordMatch: #(3 8).
					self step.
					(currentCharacter <= $ or: 
							[(currentCharacter between: $ and: $) or: 
									[(currentCharacter between: $ and: $) or: 
											[currentCharacter == $" or: 
													[(currentCharacter between: $$ and: $)) or: 
															[(currentCharacter between: $+ and: $,) or: 
																	[(currentCharacter between: $. and: $<) 
																		or: [(currentCharacter between: $> and: $[) or: [currentCharacter >= $]]]]]]]]]) 
						ifTrue: 
							[
							[self recordMatch: #(8).
							self step.
							currentCharacter <= $	 or: 
									[(currentCharacter between: $ and: $) or: 
											[(currentCharacter between: $ and: $ ) or: 
													[currentCharacter == $" or: 
															[(currentCharacter between: $$ and: $)) or: 
																	[(currentCharacter between: $+ and: $,) or: 
																			[(currentCharacter between: $. and: $<) 
																				or: [(currentCharacter between: $> and: $[) or: [currentCharacter >= $]]]]]]]]]] 
									whileTrue.
							^self reportLastMatch].
					currentCharacter == $	 or: [currentCharacter == $ ]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	^self reportLastMatch! !

WAComponent subclass: #TWWiki
	instanceVariableNames: 'model structure component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Component'!

!TWWiki methodsFor: 'accessing' stamp: 'lr 3/28/2004 09:24'!
model
	^model! !

!TWWiki methodsFor: 'rendering' stamp: 'lr 3/28/2004 09:33'!
renderWikiFooterOn: html! !

!TWWiki methodsFor: 'rendering' stamp: 'lr 3/28/2004 09:33'!
renderWikiContentOn: html
	self render: self component.! !

!TWWiki methodsFor: 'accessing' stamp: 'lr 3/28/2004 09:30'!
component
	^component! !

!TWWiki methodsFor: 'accessing' stamp: 'lr 3/28/2004 09:30'!
active
	^active! !

!TWWiki class methodsFor: 'instance creation' stamp: 'lr 3/28/2004 09:25'!
on: anObject	
	^self new
		setModel: anObject;
		yourself! !

!TWWiki methodsFor: 'actions' stamp: 'lr 3/28/2004 09:49'!
top
	self show: self model class: self model viewer! !

!TWWiki methodsFor: 'rendering' stamp: 'lr 3/28/2004 09:32'!
renderContentOn: html
	html divClass: 'wikiheader' with: [ 
		self renderWikiHeaderOn: html ].
	html divClass: 'wikicontent' with: [ 
		self renderWikiContentOn: html ].
	html divClass: 'wikifooter' with: [ 
		self renderWikiFooterOn: html ].! !

!TWWiki methodsFor: 'actions' stamp: 'lr 3/28/2004 09:48'!
edit: aStructure
	self show: aStructure class: aStructure editor! !

!TWWiki methodsFor: 'initialization' stamp: 'lr 3/28/2004 09:49'!
setModel: anObject
	model _ anObject.
	self top.! !

!TWWiki methodsFor: 'private' stamp: 'lr 3/28/2004 09:47'!
show: aStructure class: aClass
	structure _ aStructure.
	component _ aClass 
		on: structure controller: self.! !

!TWWiki methodsFor: 'rendering' stamp: 'lr 3/28/2004 10:11'!
renderWikiHeaderOn: html
	(self class organization listAtCategoryNamed: 'actions') 
		do: [ :each |
			html
				anchorWithAction: (MessageSend 
					receiver: self selector: each 
					arguments: (each numArgs isZero
						ifTrue: [ Array new ] 
						ifFalse: [ Array with: self structure ]))
				text: each asCapitalizedPhrase ]
		separatedBy: [ html space ].! !

!TWWiki methodsFor: 'actions' stamp: 'lr 3/28/2004 09:48'!
view: aStructure
	self show: aStructure class: aStructure viewer! !

WAComponent subclass: #TWRenderer
	instanceVariableNames: 'model controller renderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Component'!

!TWRenderer methodsFor: 'accessing' stamp: 'lr 3/28/2004 09:42'!
renderer
	^self renderer! !

!TWRenderer methodsFor: 'initialize-release' stamp: 'lr 3/28/2004 09:40'!
setModel: aModel controller: aController
	model _ aModel.
	controller _ aController.! !

!TWRenderer class methodsFor: 'instance creation' stamp: 'lr 3/28/2004 09:41'!
on: aModel controller: aController
	^self new
		setModel: aModel controller: aController;
		yourself! !

TWRenderer subclass: #TWEditor
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Component'!

!TWEditor methodsFor: 'visiting' stamp: 'lr 3/26/2004 22:54'!
visitRule: aRule
	renderer nextPut: $_; cr.! !

!TWEditor methodsFor: 'visiting' stamp: 'lr 3/27/2004 12:46'!
visitPage: anObject
	renderer form: [
		renderer attributeAt: 'style' put: 'width: 100%; height: 300px'.
		renderer textAreaOn: #text of: self; break.
		renderer submitButtonWithAction: [ self save ] text: 'Save'.
		renderer submitButtonWithAction: [ self cancel ] text: 'Cancel' ].! !

!TWEditor methodsFor: 'actions' stamp: 'lr 3/27/2004 10:22'!
edit! !

!TWEditor methodsFor: 'visiting' stamp: 'lr 3/26/2004 23:03'!
visitReference: anObject
	renderer nextPut: $*.
	super visitReference: anObject.
	renderer nextPut: $*.! !

!TWEditor methodsFor: 'visiting' stamp: 'lr 3/27/2004 10:29'!
visitList: anObject
	anObject children do: [ :each | 
		renderer nextPut: anObject type.
		self visit: each.
		renderer cr ]! !

!TWEditor methodsFor: 'actions' stamp: 'lr 3/27/2004 12:47'!
cancel
	self answer: nil! !

!TWEditor methodsFor: 'accessing' stamp: 'lr 3/27/2004 10:26'!
text
	text isNil ifTrue: [
		text _ String streamContents: [ :stream |
			self renderOn: stream during: [ 
				self visit: self model document ] ] ].
	^text! !

!TWEditor methodsFor: 'accessing' stamp: 'lr 3/26/2004 22:53'!
text: aString
	text _ aString! !

!TWEditor methodsFor: 'actions' stamp: 'lr 3/27/2004 10:22'!
top
	self setModel: self model parent top! !

!TWEditor methodsFor: 'visiting' stamp: 'lr 3/26/2004 23:00'!
visitParagraph: anObject
	super visitParagraph: anObject.
	renderer cr.! !

!TWEditor methodsFor: 'visiting' stamp: 'lr 3/26/2004 23:05'!
visitText: anObject
	renderer nextPutAll: anObject text.! !

!TWEditor methodsFor: 'visiting' stamp: 'lr 3/27/2004 12:57'!
visitHeading: anObject
	anObject level timesRepeat: [ renderer nextPut: $!! ].
	super visitHeading: anObject.
	renderer cr.! !

!TWEditor methodsFor: 'actions' stamp: 'lr 3/27/2004 12:50'!
save	
	| document |
	document _ [ self model parser parse: self text ]
		on: SmaCCParserError do: [ :error | nil ].
	document isNil 
		ifFalse: [ self answer: document ]! !

TWRenderer subclass: #TWViewer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Component'!

!TWViewer methodsFor: 'visiting' stamp: 'lr 3/26/2004 23:20'!
visitRule: anObject
	renderer horizontalRule.! !

!TWViewer methodsFor: 'actions' stamp: 'lr 3/27/2004 10:22'!
top
	self setModel: self model parent top.! !

!TWViewer methodsFor: 'visiting' stamp: 'lr 3/27/2004 13:01'!
visitPreformatted: anObject
	renderer preformatted: [
		anObject children
			do: [ :each | self visitAll: each children ]
			separatedBy: [ renderer text: Character cr asString ] ]! !

!TWViewer methodsFor: 'visiting' stamp: 'lr 3/27/2004 13:00'!
visitList: anObject
	anObject isOrdered
		ifTrue: [ renderer orderedList: [ super visitList: anObject ] ]
		ifFalse: [
			anObject isUnordered
				ifTrue: [ renderer unorderedList: [ super visitList: anObject ] ]
				ifFalse: [
					anObject isPreformatted 
						ifTrue: [ self visitPreformatted: anObject ] ] ].! !

!TWViewer methodsFor: 'visiting' stamp: 'lr 3/27/2004 12:58'!
visitParagraph: anObject
	anObject children isEmpty ifFalse: [
		renderer paragraph: [ super visitParagraph: anObject ] ].! !

!TWViewer methodsFor: 'visiting' stamp: 'lr 3/27/2004 10:13'!
visitText: anObject
	renderer text: anObject text.! !

!TWViewer methodsFor: 'actions' stamp: 'lr 3/27/2004 10:22'!
view! !

!TWViewer methodsFor: 'visiting' stamp: 'lr 3/27/2004 10:01'!
visitStructure: anObject! !

!TWViewer methodsFor: 'visiting' stamp: 'lr 3/27/2004 16:12'!
visitSmiley: anObject
	renderer image: (renderer urlForDocument: anObject mime) width: 16 height: 16! !

!TWViewer methodsFor: 'visiting' stamp: 'lr 3/28/2004 09:39'!
visitPage: anObject
	self visit: anObject document.
	self visitStructure: anObject.! !

!TWViewer methodsFor: 'visiting' stamp: 'lr 3/27/2004 10:13'!
visitReference: anObject
	| existing |
	anObject isUrl
		ifTrue: [
			renderer
				anchorWithUrl: anObject text
				do: [ super visitReference: anObject ] ]
		ifFalse: [
			existing _ self model parent includes: anObject text.
			existing 
				ifTrue: [
					renderer
						anchorWithAction: [ self setModel: (self model parent at: anObject text) ]
						do: [ super visitReference: anObject ] ]
				ifFalse: [
					renderer
						anchorWithAction: [ self setModel: (self model parent add: (TWPage title: anObject text)) ]
						do: [ super visitReference: anObject ].
					renderer strong: '?' ] ]! !

!TWViewer methodsFor: 'visiting' stamp: 'lr 3/27/2004 10:11'!
visitHeading: anObject
	renderer heading: [ super visitHeading: anObject ] level: anObject level! !

!TWViewer methodsFor: 'actions' stamp: 'lr 3/28/2004 09:38'!
visitFolder: anObject
	renderer unorderedList: [
		anObject children do: [ :each |
			renderer listItem: [
				renderer 
					anchorWithAction: [ renderer goTo: each ] 
					text: each title ] ] ].! !

!TWViewer methodsFor: 'visiting' stamp: 'lr 3/26/2004 23:20'!
visitListItem: anObject
	renderer listItem: [ super visitListItem: anObject ].! !

!TWRenderer methodsFor: 'rendering' stamp: 'lr 3/28/2004 09:42'!
renderContentOn: aRenderer
	self renderOn: aRenderer during: [
		self visit: self model ].! !

!TWRenderer methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:36'!
visitList: anObject
	self visitComposed: anObject! !

!TWRenderer methodsFor: 'visiting' stamp: 'lr 3/26/2004 22:41'!
visitHeading: anObject
	self visitComposed: anObject! !

!TWRenderer methodsFor: 'accessing' stamp: 'lr 3/28/2004 09:42'!
controller
	^self controller! !

!TWRenderer methodsFor: 'visiting' stamp: 'lr 3/27/2004 12:57'!
visitParagraph: anObject
	self visitComposed: anObject! !

!TWRenderer methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:36'!
visitComposed: anObject
	self visitAll: anObject children! !

!TWRenderer methodsFor: 'private' stamp: 'lr 3/27/2004 10:04'!
visitAll: aCollection separatedBy: aBlock
	aCollection 
		do: [ :each | each accept: self ]
		separatedBy: aBlock! !

!TWRenderer methodsFor: 'private' stamp: 'lr 3/27/2004 10:04'!
visitAll: aCollection
	aCollection do: [ :each | 
		each accept: self ]! !

!TWRenderer methodsFor: 'visiting' stamp: 'lr 3/28/2004 09:43'!
visitFolder: anObject
	self visitStructure: anObject.
	self visitAll: anObject children.! !

!TWRenderer methodsFor: 'accessing' stamp: 'lr 3/25/2004 17:32'!
model
	^model! !

!TWRenderer methodsFor: 'visiting' stamp: 'lr 3/28/2004 09:43'!
visitStructure: anObject! !

!TWRenderer methodsFor: 'visiting' stamp: 'lr 3/26/2004 23:19'!
visitListItem: anObject
	self visitComposed: anObject! !

!TWRenderer methodsFor: 'visiting' stamp: 'lr 3/28/2004 09:43'!
visitPage: anObject
	self visitStructure: anObject.
	self visit: anObject document.
	! !

!TWRenderer methodsFor: 'rendering' stamp: 'lr 3/26/2004 23:31'!
renderOn: aRenderer during: aBlock
	| temp |
	temp _ renderer.
	renderer _ aRenderer.
	aBlock value.
	renderer _ temp.! !

!TWRenderer methodsFor: 'visiting' stamp: 'lr 3/26/2004 22:43'!
visitRule: anObject! !

!TWRenderer methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:34'!
visitText: anObject! !

!TWRenderer methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:33'!
visitSmiley: anObject
	self visitText: anObject! !

!TWRenderer methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:36'!
visitDocument: anObject
	self visitComposed: anObject! !

!TWRenderer methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:37'!
visitReference: anObject
	self visitComposed: anObject! !

!TWRenderer methodsFor: 'private' stamp: 'lr 3/27/2004 10:00'!
visit: anObject
	anObject accept: self! !

Object subclass: #TWDocumentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

TWDocumentNode subclass: #TWText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWText methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:31'!
accept: aVisitor
	aVisitor visitText: self! !

!TWText class methodsFor: 'instance creation' stamp: 'lr 3/26/2004 22:36'!
text: aString
	^self new
		text: aString;
		yourself! !

TWText subclass: #TWSmiley
	instanceVariableNames: ''
	classVariableNames: 'Smilies'
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWSmiley class methodsFor: 'private' stamp: 'lr 3/27/2004 16:16'!
binaryTongue
	"(self readFromFile: 'tongue.gif') storeString"

	^#(71 73 70 56 57 97 15 0 15 0 247 0 0 0 0 0 24 99 181 33 99 181 33 107 189 33 107 198 33 115 206 33 115 214 33 123 222 41 123 222 41 132 222 49 132 222 57 140 222 66 140 222 74 148 231 82 148 231 82 156 231 90 156 231 99 165 231 107 165 231 107 173 231 115 173 239 132 0 0 198 198 255 255 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 33 249 4 1 0 0 22 0 44 0 0 0 0 15 0 15 0 0 8 141 0 45 8 20 8 160 96 193 129 8 45 20 132 224 128 193 2 5 7 17 2 136 32 33 2 67 6 10 16 20 0 48 112 162 4 10 21 33 52 88 160 145 0 71 133 31 11 74 16 89 208 128 73 133 16 40 22 180 216 160 96 1 2 2 10 58 136 25 178 97 198 155 57 1 48 216 9 225 226 67 141 3 130 46 96 0 160 65 3 135 63 1 36 45 168 64 193 2 131 88 147 230 84 136 0 1 196 11 21 46 72 21 176 85 97 129 179 0 46 168 5 64 182 172 66 2 112 13 182 61 217 145 109 219 160 9 235 26 76 24 16 0 59 ) asByteArray! !

!TWSmiley class methodsFor: 'accessing' stamp: 'lr 3/26/2004 22:37'!
smileyAt: aString ifAbsent: aBlock
	^Smilies at: aString ifAbsent: aBlock! !

!TWSmiley class methodsFor: 'private' stamp: 'lr 3/27/2004 16:16'!
binarySick
	"(self readFromFile: 'sick.gif') storeString"

	^#(71 73 70 56 57 97 15 0 15 0 247 0 0 0 0 0 24 99 181 33 99 181 33 107 189 33 107 198 33 115 206 33 115 214 33 123 222 41 123 222 41 132 222 49 132 222 57 140 222 66 140 222 74 148 231 82 148 231 82 156 231 90 156 231 99 165 231 107 165 231 107 173 231 115 173 239 198 198 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 33 249 4 1 0 0 21 0 44 0 0 0 0 15 0 15 0 0 8 141 0 43 8 20 8 160 96 193 129 8 43 20 132 224 128 193 2 5 7 17 2 136 32 33 2 67 6 10 16 20 0 48 112 162 4 10 21 33 52 88 160 145 0 71 133 31 37 168 20 89 208 128 73 133 16 40 22 180 216 160 96 1 2 2 10 58 136 185 176 97 198 155 57 1 48 216 9 225 226 67 141 3 130 46 96 208 160 169 195 159 4 146 22 84 160 96 193 130 169 72 147 230 84 136 0 1 0 170 0 10 12 0 32 96 171 194 2 104 209 154 36 91 246 164 66 2 112 163 106 53 219 145 109 217 160 9 235 26 76 24 16 0 59 ) asByteArray! !

!TWSmiley class methodsFor: 'class initialization' stamp: 'lr 3/27/2004 16:19'!
initializeSmilies
	Smilies _ Dictionary new.
	self addSmilies: #( ':)' ':-)' ) array: self binarySmile.
	self addSmilies: #( ':(' ';(' ':-(' ';-(' ) array: self binarySad.
	self addSmilies: #( ':o' ':0' ':O' ':-0' ':-o' ':-O' ) array: self binaryShocked.
	self addSmilies: #( ':D' ':-D' ) array: self binaryBiggrin.
	self addSmilies: #( ';)' ';-)' ) array: self binaryWink.
	self addSmilies: #( ':p' ':P' ':-p' ':-P' ) array: self binaryTongue.
	self addSmilies: #( ':''('  ) array: self binaryCry.
	self addSmilies: #( ':&' ) array: self binarySick.! !

!TWSmiley class methodsFor: 'accessing' stamp: 'lr 3/27/2004 16:10'!
addSmiley: aString array: aByteArray
	Smilies at: aString put: (MIMEDocument contentType: MIMEDocument contentTypeGif content: aByteArray) ! !

!TWSmiley methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:32'!
accept: aVisitor
	aVisitor visitSmiley: self! !

!TWSmiley class methodsFor: 'private' stamp: 'lr 3/27/2004 16:16'!
binaryCry
	"(self readFromFile: 'cry.gif') storeString"

	^#(71 73 70 56 57 97 15 0 15 0 247 0 0 0 0 0 24 99 181 33 99 181 33 107 189 33 107 198 33 115 214 33 123 222 41 123 222 41 132 222 49 132 222 57 140 222 66 140 222 74 148 231 82 148 231 82 156 231 90 156 231 99 165 231 107 165 231 107 173 231 115 173 239 198 198 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 33 249 4 1 0 0 20 0 44 0 0 0 0 15 0 15 0 0 8 139 0 41 8 20 8 160 96 193 129 8 41 20 124 208 96 129 130 4 7 17 2 128 16 1 2 195 5 9 14 20 0 48 112 98 132 9 21 31 48 80 160 145 0 71 133 31 11 70 16 89 176 128 73 133 15 32 0 136 16 114 228 1 0 4 4 20 108 16 51 100 195 140 46 117 2 88 192 243 193 197 135 7 42 12 16 170 96 1 131 167 6 53 42 21 154 32 129 2 5 6 11 14 88 170 83 225 129 3 16 179 114 61 9 160 128 217 172 0 4 168 61 169 144 128 91 131 106 187 74 76 27 87 104 194 142 89 19 6 4 0 59 ) asByteArray! !

!TWSmiley class methodsFor: 'private' stamp: 'lr 3/27/2004 16:16'!
binaryWink
	"(self readFromFile: 'wink.gif') storeString"

	^#(71 73 70 56 57 97 15 0 15 0 247 0 0 0 0 0 24 99 181 33 99 181 33 107 189 33 107 198 33 115 206 33 115 214 33 123 222 41 123 222 41 132 222 49 132 222 57 140 222 66 140 222 74 148 231 82 148 231 82 156 231 90 156 231 99 165 231 107 165 231 107 173 231 115 173 239 198 198 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 33 249 4 1 0 0 21 0 44 0 0 0 0 15 0 15 0 0 8 141 0 43 8 20 8 160 96 193 129 8 43 20 132 224 128 193 2 5 7 17 2 136 32 33 2 67 6 10 16 20 0 48 112 162 4 10 21 33 52 88 160 145 0 71 133 18 0 72 88 41 178 160 1 147 10 33 80 52 216 18 64 1 2 2 10 58 144 25 178 97 198 155 57 1 48 216 9 225 226 67 141 3 130 46 96 0 160 65 3 135 63 9 36 45 168 0 226 130 135 63 7 36 205 169 16 1 2 0 85 21 20 208 42 128 171 194 2 104 13 2 216 106 86 33 129 183 82 217 158 236 8 160 172 221 136 9 21 170 77 24 16 0 59 ) asByteArray! !

!TWSmiley class methodsFor: 'private' stamp: 'lr 3/27/2004 16:16'!
binaryShocked
	"(self readFromFile: 'shocked.gif') storeString"

	^#(71 73 70 56 57 97 15 0 15 0 247 0 0 0 0 0 54 114 197 54 115 199 55 117 200 57 118 200 58 119 202 60 120 202 61 121 203 65 123 204 67 125 204 68 126 205 0 255 0 71 129 206 75 131 207 77 132 207 79 133 207 82 135 208 86 137 209 87 139 210 89 141 210 90 142 211 92 143 211 93 144 213 97 146 214 100 149 215 107 153 217 109 155 217 110 156 218 112 157 218 117 161 220 122 164 221 124 165 221 125 166 222 132 172 225 135 174 226 141 177 227 145 181 229 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33 249 4 1 0 0 11 0 44 0 0 0 0 15 0 15 0 0 8 168 0 23 8 20 8 160 96 193 129 8 23 20 244 208 65 3 134 10 7 17 2 8 33 34 4 136 14 25 46 72 104 0 96 224 196 17 36 70 132 240 176 1 195 4 7 9 58 42 20 65 162 160 136 15 28 10 62 72 169 208 67 136 17 5 71 110 40 136 146 64 193 14 32 40 90 196 168 177 1 130 1 5 53 116 240 240 129 161 195 10 16 24 28 16 80 16 67 134 13 28 54 100 192 96 33 66 131 4 5 2 20 172 112 1 131 217 11 21 34 56 80 96 64 128 88 133 18 38 80 160 96 208 192 129 1 111 21 54 112 192 151 35 0 3 1 2 171 84 152 160 176 65 183 121 61 2 32 48 0 113 196 132 10 13 14 22 24 16 0 59 ) asByteArray! !

!TWSmiley class methodsFor: 'accessing' stamp: 'lr 3/26/2004 09:48'!
smileyAt: aString
	^Smilies at: aString! !

!TWSmiley class methodsFor: 'private' stamp: 'lr 3/27/2004 16:16'!
binaryBiggrin
	"(self readFromFile: 'biggrin.gif') storeString"
	
	 ^#(71 73 70 56 57 97 15 0 15 0 247 0 0 0 0 0 24 99 181 33 99 181 33 107 189 33 107 198 33 115 214 41 123 222 49 132 222 57 140 222 66 140 222 74 148 231 82 148 231 82 156 231 90 156 231 99 165 231 107 165 231 107 173 231 198 198 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 33 249 4 1 0 0 17 0 44 0 0 0 0 15 0 15 0 0 8 126 0 35 8 20 8 160 96 193 129 8 35 20 108 176 32 1 130 3 7 17 2 112 240 192 1 195 4 7 12 20 0 48 112 226 131 130 22 21 20 44 64 128 163 194 143 15 62 54 0 128 192 0 128 146 10 27 80 76 25 178 37 73 1 5 23 24 220 185 19 39 128 4 0 36 72 8 42 148 40 0 159 8 140 10 29 90 212 39 196 162 75 141 226 84 232 146 41 212 163 38 1 20 216 72 116 232 209 169 4 9 148 236 9 182 227 87 1 104 35 38 84 184 51 97 64 0 0 59 ) asByteArray! !

!TWSmiley class methodsFor: 'private' stamp: 'lr 3/27/2004 16:16'!
binarySad
	"(self readFromFile: 'sad.gif') storeString"

	^#(71 73 70 56 57 97 15 0 15 0 247 0 0 0 0 0 54 114 197 55 115 197 56 116 198 57 116 198 60 118 199 61 119 199 62 120 200 63 120 200 65 122 201 68 124 202 70 125 202 71 126 203 0 255 0 73 128 203 78 132 205 80 133 206 82 134 207 86 137 208 87 138 208 88 139 209 90 140 209 91 141 210 96 144 211 97 145 212 103 150 214 104 151 214 106 152 215 109 154 216 111 156 217 113 157 217 116 159 218 122 163 220 124 164 221 130 169 223 132 171 224 137 174 226 139 176 226 141 177 227 192 192 192 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33 249 4 1 0 0 13 0 44 0 0 0 0 15 0 15 0 0 8 157 0 27 8 20 8 160 96 193 129 8 27 20 252 208 65 3 134 10 7 17 2 24 33 34 196 7 14 25 46 76 120 0 96 32 0 18 37 72 136 0 225 97 3 6 10 16 24 116 84 88 194 132 193 151 41 59 2 16 65 2 0 10 20 39 108 222 4 192 0 65 193 16 58 113 6 205 121 96 161 205 156 57 81 0 56 145 179 64 65 14 30 94 74 69 64 160 96 134 13 88 51 96 176 32 1 130 131 4 5 4 200 196 64 86 170 2 3 3 86 2 160 64 1 192 132 8 15 28 40 0 64 32 192 74 133 16 32 196 93 144 192 64 221 187 4 1 240 69 80 32 45 96 137 47 19 6 4 0 59 ) asByteArray! !

!TWSmiley methodsFor: 'accessing' stamp: 'lr 3/27/2004 16:11'!
mime
	^self class smileyAt: self text! !

!TWSmiley class methodsFor: 'private' stamp: 'lr 3/27/2004 16:16'!
binarySmile
	"(self readFromFile: 'smile.gif') storeString"

	^#(71 73 70 56 57 97 15 0 15 0 247 0 0 0 0 0 24 99 181 33 99 181 33 107 189 33 107 198 33 115 206 33 115 214 33 123 222 41 123 222 41 132 222 49 132 222 57 140 222 66 140 222 74 148 231 82 148 231 82 156 231 90 156 231 99 165 231 107 165 231 107 173 231 115 173 239 198 198 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 33 249 4 1 0 0 21 0 44 0 0 0 0 15 0 15 0 0 8 140 0 43 8 20 8 160 96 193 129 8 43 20 132 224 128 193 2 5 7 17 2 136 32 33 2 67 6 10 16 20 0 48 112 162 4 10 21 33 52 88 160 145 0 71 133 31 11 74 16 89 208 128 73 133 16 40 22 180 216 160 96 1 2 2 10 58 136 25 178 97 198 155 57 1 48 216 9 225 226 67 141 3 130 46 96 208 160 169 195 159 4 146 22 84 0 113 193 195 159 3 0 8 200 169 16 1 2 0 84 21 20 200 186 245 36 128 2 104 13 22 220 202 149 32 129 183 81 147 150 77 184 150 109 208 132 29 213 38 12 8 0 59 ) asByteArray! !

!TWSmiley class methodsFor: 'accessing' stamp: 'lr 3/27/2004 00:10'!
smilies
	^Smilies keys! !

!TWSmiley class methodsFor: 'class initialization' stamp: 'lr 3/26/2004 09:42'!
initialize
	self initializeSmilies.! !

!TWSmiley class methodsFor: 'private' stamp: 'lr 3/27/2004 16:05'!
readFromFile: aString
	| stream array |
	stream _ FileStream readOnlyFileNamed: aString.
	[ array _ stream binary; next: stream size ]
		ensure: [ stream close ].	
	^array asArray storeString ! !

!TWSmiley class methodsFor: 'accessing' stamp: 'lr 3/26/2004 09:48'!
includesSmiley: aString
	^Smilies includes: aString! !

!TWSmiley class methodsFor: 'accessing' stamp: 'lr 3/27/2004 16:11'!
addSmilies: aCollection array: aForm
	aCollection do: [ :each |
		self addSmiley: each array: aForm ]! !

!TWText methodsFor: 'accessing' stamp: 'lr 3/26/2004 09:32'!
text: aString
	text _ aString! !

!TWText methodsFor: 'accessing' stamp: 'lr 3/26/2004 09:32'!
text
	^text! !

!TWDocumentNode methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:30'!
accept: aVisitor! !

TWDocumentNode subclass: #TWRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWRule methodsFor: 'visiting' stamp: 'lr 3/26/2004 22:43'!
accept: aVisitor
	aVisitor visitRule: self! !

TWDocumentNode subclass: #TWComposed
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWComposed methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:35'!
accept: aVisitor
	aVisitor visitComposed: self! !

TWComposed subclass: #TWHeading
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWHeading methodsFor: 'visiting' stamp: 'lr 3/26/2004 22:40'!
accept: aVisitor
	aVisitor visitHeading: self! !

!TWHeading methodsFor: 'accessing' stamp: 'lr 3/26/2004 22:41'!
level
	^level! !

!TWHeading methodsFor: 'accessing' stamp: 'lr 3/26/2004 22:41'!
level: anInteger
	level _ anInteger! !

!TWHeading class methodsFor: 'instance creation' stamp: 'lr 3/27/2004 00:52'!
withAll: aCollection level: anInteger
	^(self withAll: aCollection)
		level: anInteger;
		yourself! !

!TWComposed methodsFor: 'accessing' stamp: 'lr 3/27/2004 08:58'!
children
	^children.! !

!TWComposed methodsFor: 'accessing' stamp: 'lr 3/27/2004 08:58'!
children: aCollection
	children _ aCollection.! !

TWComposed subclass: #TWParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWParagraph methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:38'!
accept: aVisitor
	aVisitor visitParagraph: self! !

TWComposed subclass: #TWReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWReference methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:39'!
accept: aVisitor
	aVisitor visitReference: self! !

!TWReference methodsFor: 'testing' stamp: 'lr 3/27/2004 10:13'!
isUrl
	^('*://*' match: self text)
		or: [ self text beginsWith: 'mailto:' ]! !

!TWReference methodsFor: 'accessing' stamp: 'lr 3/26/2004 23:47'!
text
	^String streamContents: [ :stream |
		self children do: [ :each |
			(each isKindOf: TWText)
				ifTrue: [ stream nextPutAll: each text ] ] ]! !

TWComposed subclass: #TWDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWDocument methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:38'!
accept: aVisitor
	aVisitor visitDocument: self! !

!TWComposed methodsFor: 'initialize-release' stamp: 'lr 3/27/2004 08:58'!
initialize
	children _ OrderedCollection new.! !

!TWComposed methodsFor: 'accessing' stamp: 'lr 3/27/2004 08:57'!
add: anObject
	self children addLast: anObject.! !

TWComposed subclass: #TWListItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWListItem methodsFor: 'visiting' stamp: 'lr 3/26/2004 23:19'!
accept: aVisitor
	aVisitor visitListItem: self! !

!TWComposed class methodsFor: 'instance creation' stamp: 'lr 3/26/2004 23:53'!
withAll: aCollection
	^self new
		children: aCollection;
		yourself! !

TWComposed subclass: #TWList
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Document'!

!TWList class methodsFor: 'defaults' stamp: 'lr 3/26/2004 23:00'!
unformatted
	^self type: #=! !

!TWList methodsFor: 'accessing' stamp: 'lr 3/26/2004 22:57'!
type: aCharacter
	type _ aCharacter! !

!TWList methodsFor: 'visiting' stamp: 'lr 3/26/2004 09:38'!
accept: aVisitor
	aVisitor visitList: self! !

!TWList methodsFor: 'testing' stamp: 'lr 3/26/2004 23:21'!
isOrdered
	^self type = $#! !

!TWList class methodsFor: 'instance creation' stamp: 'lr 3/27/2004 00:54'!
type: aCharacter
	^self new
		type: aCharacter
		yourself! !

!TWList class methodsFor: 'defaults' stamp: 'lr 3/26/2004 23:01'!
unordered
	^self type: $-! !

!TWList class methodsFor: 'instance creation' stamp: 'lr 3/27/2004 09:24'!
withAll: aCollection type: aCharacter
	^self new
		children: aCollection;
		type: aCharacter;
		yourself! !

!TWList methodsFor: 'testing' stamp: 'lr 3/26/2004 23:21'!
isPreformatted
	^self type = $=! !

!TWList class methodsFor: 'defaults' stamp: 'lr 3/26/2004 23:00'!
ordered
	^self type: $#! !

!TWList methodsFor: 'accessing' stamp: 'lr 3/26/2004 22:57'!
type
	^type! !

!TWList methodsFor: 'testing' stamp: 'lr 3/26/2004 23:21'!
isUnordered
	^self type = $-! !

Object subclass: #TWStructure
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Core'!

!TWStructure methodsFor: 'testing' stamp: 'lr 3/27/2004 09:07'!
isRoot
	^self parent isNil! !

!TWStructure methodsFor: 'configuration' stamp: 'lr 3/28/2004 09:29'!
parser
	^TWParser! !

!TWStructure methodsFor: 'configuration' stamp: 'lr 3/28/2004 09:29'!
editor
	^TWEditor! !

!TWStructure methodsFor: 'configuration' stamp: 'lr 3/28/2004 09:29'!
viwer
	^TWViewer! !

!TWStructure class methodsFor: 'instance creation' stamp: 'lr 3/27/2004 09:44'!
parent: aStructure
	^self new
		parent: aStructure;
		yourself! !

TWStructure subclass: #TWFolder
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Core'!

!TWFolder methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:44'!
title
	^'Top'! !

!TWFolder methodsFor: 'initialize-release' stamp: 'lr 3/27/2004 09:16'!
initialize
	super initialize.
	self initializeChildren.
	self initializeTop.! !

!TWFolder methodsFor: 'accessing' stamp: 'lr 3/27/2004 10:32'!
top
	^self at: self title ifAbsent: [ self initializeTop; top ]! !

!TWFolder methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:41'!
at: aString
	^children at: aString! !

!TWFolder methodsFor: 'accessing' stamp: 'lr 3/28/2004 09:44'!
children
	^children values! !

!TWFolder methodsFor: 'initialize-release' stamp: 'lr 3/27/2004 15:40'!
initializeTop
	self add: (TWPage new
		title: self title;
		document: (TWDocument withAll: {
			TWHeading 
				withAll: { TWText text: 'Welcome to TinyWiki' }
				level: 1.
			TWParagraph
				withAll: { TWText text: 'TinyWiki is a fork of SmallWiki ('. TWReference withAll: { TWText text: 'http://kilana.unibe.ch:9090/smallwiki' }. TWText text: '), implementing the most basic features only. However it is fully object-oriented, easily extensible and useable in different contexts.' }.
			TWParagraph
				withAll: { TWText text: 'The following markup is currently supported:' }.
			TWList
				withAll: {
					TWListItem withAll: { TWText text: '<strong>Paragraph:</strong> Carriage returns are used to form paragraphs.' }.
					TWListItem withAll: { TWText text: '<strong>Header:</strong> Lines starting with <code>!!</code> becomes a header.' }.
					TWListItem withAll: { TWText text: '<strong>Hoizontal Rule:</strong> A line with <code>_</code> becomes a horizontal rule.' }.
					TWListItem withAll: { TWText text: '<strong>Lists:</strong> A block of lines starting with <code>#</code> or <code>-</code> becomes an ordered-/unordered list.' }.
					TWListItem withAll: { TWText text: '<strong>Preformatted:</strong> A block of lines starting with <code>=</code> becomes a preformatted text.' }.
					TWListItem withAll: { TWText text: '<strong>Links:</strong> Text between <code>*</code> becomes a link. If the text withing the stars starts out with a common know protocol, an external-link will be created else an internal one.' }.
					TWListItem withAll: { TWText text: '<strong>Smilies:</strong> Putting those common-tags like <code>;&shy;)</code>, will turn them into images.'. TWSmiley text: ':P' }.
					TWListItem withAll: { TWText text: '<strong>XHTML:</strong> Use any valid XHTML you want.' }. }
				type: $-.
			TWParagraph
				withAll: { TWText text: 'If you are looking for more advanced features, check-out SmallWiki available in VisualWorks and Squeak. Enjoy.'. } } ))! !

!TWFolder methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:41'!
includes: aString
	^children includesKey: aString! !

!TWFolder methodsFor: 'initialize-release' stamp: 'lr 3/27/2004 09:16'!
initializeChildren
	children _ Dictionary new.! !

!TWFolder methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:41'!
at: aString ifAbsent: aBlock
	^children at: aString ifAbsent: aBlock! !

!TWFolder methodsFor: 'visiting' stamp: 'lr 3/27/2004 10:03'!
accept: aVisitor
	aVisitor visitFolder: self! !

!TWFolder methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:57'!
add: aStructure
	^children 
		at: aStructure title 
		put: (aStructure parent: self).! !

TWStructure subclass: #TWPage
	instanceVariableNames: 'title document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyWiki-Core'!

!TWPage methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:45'!
title: aString
	title _ aString! !

!TWPage methodsFor: 'accessing' stamp: 'lr 3/25/2004 17:27'!
document: aDocument
	document _ aDocument! !

!TWPage methodsFor: 'initialize-release' stamp: 'lr 3/27/2004 09:12'!
initialize
	super initialize.
	self initializeDocument.! !

!TWPage methodsFor: 'accessing' stamp: 'lr 3/25/2004 17:27'!
document
	^document! !

!TWPage methodsFor: 'initialize-release' stamp: 'lr 3/27/2004 09:14'!
initializeDocument
	document _ TWDocument withAll: {
		TWParagraph withAll: { 
			TWText text: 'Edit your page' } }.! !

!TWPage class methodsFor: 'instance creation' stamp: 'lr 3/27/2004 13:02'!
title: aString
	^self new
		title: aString;
		yourself! !

!TWPage methodsFor: 'visiting' stamp: 'lr 3/27/2004 10:03'!
accept: aVisitor
	aVisitor visitPage: self! !

!TWPage methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:45'!
title
	^title! !

!TWStructure methodsFor: 'visiting' stamp: 'lr 3/27/2004 10:03'!
accept: aVisitor
	aVisitor visitStructure: self! !

!TWStructure methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:11'!
parent: aStructure
	parent _ aStructure
! !

!TWStructure methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:07'!
parent
	^parent! !

!TWStructure methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:44'!
title
	self subclassResponsiblity! !
TWSmiley initialize!
